package Clock;

import java.awt.*;
import java.util.Date;

public class Clock
	extends java.applet.Applet
	implements Runnable
{
	private Font myFont;
	
	public void init() {
		myFont = new Font("Helvetica", Font.PLAIN, 72);
	}

	Thread clockThread = null;
	public void start() {
		if (clockThread == null) {
			clockThread = new Thread(this, "Clock");
						// NB: creates its own thread
			clockThread.start();
		}
	}
	
	public void run() {
		// terminates when clockThread is set to null in stop()
		while (Thread.currentThread() == clockThread) {
			repaint();
			try { clockThread.sleep(1000); }
			catch (InterruptedException e){ }
		}
	}
	public void paint(Graphics g) {
		// Should be able to set this just once
		g.setFont(myFont);
		// kludge translation!
		g.translate(0,10+g.getClipBounds().height/2);
		
		Date now = new Date();
		g.drawString(format(now.getHours())
			+ ":" + format(now.getMinutes())
			+ ":" + format(now.getSeconds()),
			5, 10);
	}
	public void stop() { clockThread = null; }
	public static String format(int n) {
		if (n==0) {
			return "00";
		} else if (n<10) {
			return "0" + n;
		} else {
			return "" + n;
		}
	}
}
