package Counter;

/**
* The most basic form of conditional synchronization.
*/
public class BoundedCounterV0 implements BoundedCounter {
	protected long count_ = MIN;
	
	public synchronized long value() {
		return count_;
	}

	public synchronized void inc() {
		while (count_ >= MAX)
			try { wait(); }
			catch(InterruptedException ex) { };
		count_ ++;
		notifyAll();
	}

	public synchronized void dec() {
		while (count_ <= MIN)
			try { wait(); }
			catch(InterruptedException ex) { };
		count_ --;
		notifyAll();
	}
}
