package Counter;

/**
* Illustrates Optimistic updates.
*/
public class BoundedCounterVOPT implements BoundedCounter { 
	protected Long count_ = new Long(MIN);
	// protected volatile Long count_ = new Long(MIN);
	protected synchronized boolean commit(Long oldc, Long newc) {
		boolean success = (count_ == oldc);
		if (success)
			count_ = newc;
		else
			System.out.println("COMMIT FAILED -- RETRYING");
		return success;
	}
	public long value() { return count_.longValue(); }
	public void inc() { 
		for (;;) {						// thinly disguised busy-wait!
			Long c = count_; long v = c.longValue();
			if (v < MAX && commit(c, new Long(v+1))) break;
			Thread.currentThread().yield();														// is there another thread?!
		}
	}
	public void dec() { 
		for (;;) {
			Long c = count_; long v = c.longValue();
			if (v > MIN && commit(c, new Long(v-1))) break;
			Thread.currentThread().yield();
		}
	}
}
