package Counter;

/**
* Illustrates State Variables.
*/
public class BoundedCounterVSV extends BoundedCounterV0 {
	static final int BOTTOM = 0; // logical states
	static final int MIDDLE = 1;
	static final int TOP = 2;
	protected int state_ = BOTTOM; // state variable

	public synchronized void inc() { 
		while (state_ == TOP) // consult logical state
			try { wait(); }
			catch(InterruptedException ex) {};
		++count_;				// modify actual state
		checkState();		// sync logical state
	} 
	
	public synchronized void dec() {
			while (state_ == BOTTOM) // consult logical state
			try { wait(); }
			catch(InterruptedException ex) {};
		--count_;				// modify actual state
		checkState();		// sync logical state
	} 

	protected synchronized void checkState() {
		int oldState = state_;
		if (count_ == MIN)
			state_ = BOTTOM;
		else if (count_ == MAX)
			state_ = TOP;
		else
			state_ = MIDDLE;
		
		if (state_ != oldState
						&& (oldState == TOP
							|| oldState == BOTTOM))
			notifyAll();
	}
}
