package Counter;

import java.util.*;

public class Main 
{
	public static final int loopSize = 10;
	private int errors = 0;

	static public void main(String[] args) 
	{
		new Main().doit();
		// new Main().nestedMonitor();
	}
	
	public void doit() {
		System.out.println("Starting Bounded Counter test suite");
		/*
		tester(new BoundedCounterV0());
		tester(new BoundedCounterV1());
		tester(new BoundedCounterVST());
		tester(new BoundedCounterVSV());
		tester(new BoundedCounterVNL());
		*/
		// tester(new BoundedCounterVCV());
		tester(new BoundedCounterVSem());
		// tester(new BoundedCounterVOPT());
		System.out.println(((errors == 0)?"NO":(""+errors)) + " ERRORS OCCURRED");
	}
	
	public void nestedMonitor() {
		System.out.println("Starting Nested Monitor");
		tester(new BoundedCounterVBAD());
		System.out.println(((errors == 0)?"NO":(""+errors)) + " ERRORS OCCURRED");
	}
	
	public void tester(BoundedCounter bc) {
		Vector threads = new Vector();
		Enumeration e;
		System.out.println("START: bc = " + bc.value());
		
		threads.addElement(incThread(bc));
		threads.addElement(decThread(bc));
		threads.addElement(incThread(bc));
		threads.addElement(decThread(bc));
		
		e = threads.elements();
		while (e.hasMoreElements()) {
			((Thread) e.nextElement()).start();
		}

		e = threads.elements();
		while (e.hasMoreElements()) {
			try {
				((Thread) e.nextElement()).join(); // Block here
			} catch (InterruptedException err) {
				throw new Error("Can't join thread?!");
			}
		}
		System.out.println("DONE: bc = " + bc.value() + "\n");
		assert(bc.value() == 0);
	}
	
	public Thread incThread(BoundedCounter arg) {
		final BoundedCounter bc = arg;
		return new Thread() {
			public void run() {
				int i = 0;
				for (i=0; i<loopSize; i++) {
					randomSleep();
					bc.inc();
					System.out.println("inc: bc = " + bc.value());
					assert(bcInvariant(bc));
				}
			}
		};
	}
	
	public Thread decThread(BoundedCounter arg) {
		final BoundedCounter bc = arg;
		return new Thread() {
			public void run() {
				int i = 0;
				for (i=0; i<loopSize; i++) {
					randomSleep();
					bc.dec();
					// randomSleep();
					System.out.println("dec: bc = " + bc.value());
					assert(bcInvariant(bc));
				}
			}
		};
	}
	
	public void randomSleep() {
		try {
			Thread.sleep((int)(Math.random() * 100));
		} catch (InterruptedException e) { }
	}
	
	private boolean bcInvariant(BoundedCounter bc) {
		return (bc.value() >= BoundedCounter.MIN
			&& bc.value() <= BoundedCounter.MAX);
	}
	
	private void assert(boolean assertion) {
		if (!assertion) {
			errors ++;
			throw new Error("assertion failed");
		}
	}
}
