package Slot;

public class EarlyReplyDemo {

	public static void demo() {
		EarlyReplyDemo server = new EarlyReplyDemo();
		System.out.println("Starting EarlyReplyDemo.demo()");
		for (int n=4;n<=6;n++) {
			startDemoThread(server, n);
		}
	}

	protected static void startDemoThread
		(final EarlyReplyDemo server, final int n) {
		new Thread() {
			public void run() {
				System.out.println("CALLING service("+n+")");
				int val = ((Integer) server.service(n)).intValue();
				System.out.println("GOT service("+n+") = " + val);
			}
		}.start();
	}

	protected int request=0;
	
	protected int id() { return request; }

	public Object service(final int n) {	// unsynchronized
		final Slot reply = new Slot();
		final EarlyReplyDemo host = this;
		new Thread() {											// Helper
			public void run() {
				synchronized (host) {
					reply.put(host.compute(n));
					host.cleanup();								// retain lock
				}
			}
		}.start();
		return reply.get(); // early reply
	}

	protected Integer compute(int arg) {
		this.request = arg;
		int result = factorial(this.request);
		System.out.println(id() + " Computed result: " + result);
		return new Integer(result);
	}

	protected int factorial(int n) {
		if (n <= 0) return 1;
		else return n*factorial(n-1);
	}

	protected void cleanup() {
		System.out.println(id() + " Cleaning up");
		randomSleep();
		System.out.println(id() + " FINISHED cleaning up");
		this.request = 0;
	}
	
	protected void randomSleep() {
		try {
			Thread.sleep((int)(Math.random() * 1000));
		} catch (InterruptedException e) { }
	}
}
