/* 
	File: Garden.java
*/

package garden;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import support.*;

/** the Garden Class
 */

public class Garden extends Applet implements ActionListener 
{
	Turnstile west_;
	Turnstile east_;
	Counter total_;
	Counter westEntry_;
	Counter eastEntry_;

	public final static int MAX = 20;

	public void init() 
	{

		setLayout( new BorderLayout() ); 

		// Go button 
		Panel p0= new Panel();
		Button goButton = new Button( "Go" );

		p0.add( goButton );
		goButton.addActionListener( this ); 
		goButton.setFont( new Font( "Helvetica",Font.BOLD,24 ) );
		add( p0, BorderLayout.SOUTH ); 


		Panel p1 = new Panel( new GridLayout(1,3) ); 
		total_ = new Counter( "Counter" );
		westEntry_ = new Counter( "West", Color.green );
		eastEntry_ = new Counter( "East", Color.green );
		p1.add( westEntry_ ); 
		p1.add( total_ ); 
		p1.add( eastEntry_ ); 

		add( p1, BorderLayout.CENTER ); 
	}

	private void go() 
	{
		total_.setValue( 0 );
		westEntry_.setValue( 0 );
		eastEntry_.setValue( 0 );

		west_ = new Turnstile( westEntry_, total_ );
		east_ = new Turnstile( eastEntry_, total_ );
		west_.start();
		east_.start();
	}

	public void actionPerformed( ActionEvent evt ) 
	{
		// start threads only if they are not active
		if ( (west_ == null && east_ == null) ||
			 (!west_.isAlive() && !east_.isAlive()) )
			go();
	}

}

